package metadata

import "time"

type Album struct {
	License                License
	SourceUniqueIdentifier string
	Name                   []Name
	Roles                  []Role
	Art                    []Name
	Identifiers            []Name
	Tags                   []Name
	Links                  []Link
	Discs                  []Disc
	ReleaseDate            time.Time
}

type Disc struct {
	//TODO: add name?
	Name        []Name
	Identifiers []Name
	Links       []Link
	Tracks      []Track
}

type Track struct {
	Name     []Name
	Roles    []Role
	Links    []Link
	Duration time.Duration
	Lyrics   LyricGetter
}

type Role struct {
	Kind  string
	Name  []Name
	Group string
}

type Link struct {
	Kind string
	Name []Name
}

type Name struct {
	Kind string
	Name string
}

type Lyrics struct {
	Identifiers []Name
	Entries     []LyricTextEntry
}

type LyricTextEntry struct {
	Start   time.Duration
	End     time.Duration
	Content []Name
}

type LyricGetter func() *Lyrics
