package wiki

import "fmt"

type Template struct {
	Name       string
	Parameters map[string][]interface{}
}

func NewTemplate(name string) *Template {
	return &Template{
		Name:       name,
		Parameters: make(map[string][]interface{}),
	}
}

func (t *Template) AddParameterUnkeyed(value interface{}) {
	t.Parameters[fmt.Sprintf("%d", len(t.Parameters))] = []interface{}{value}
}

func (t *Template) AddParameter(key string, value interface{}) {
	if _, ok := t.Parameters[key]; !ok {
		t.Parameters[key] = make([]interface{}, 0, 1)
	}
	t.Parameters[key] = append(t.Parameters[key], value)
}
